import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkUsersVip, ThinkUsersVipParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkUsersVip(params: ThinkUsersVipParam) {
  const res = await request.get<ApiResult<PageResult<ThinkUsersVip>>>(
    THINK_API_URL + '/think/think-users-vip/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkUsersVip(params?: ThinkUsersVipParam) {
  const res = await request.get<ApiResult<ThinkUsersVip[]>>(
    THINK_API_URL + '/think/think-users-vip',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkUsersVip(data: ThinkUsersVip) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-vip',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkUsersVip(data: ThinkUsersVip) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-vip',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkUsersVip(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-vip/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkUsersVip(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-vip/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkUsersVip(id: number) {
  const res = await request.get<ApiResult<ThinkUsersVip>>(
    THINK_API_URL + '/think/think-users-vip/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
